ompi/request/request.h File Reference.TH "ompi/request/request.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/request/request.h \- Top-level description of requests. 
.SH SYNOPSIS
.br
.PP
\fC#include 'mpi.h'\fP
.br
\fC#include 'opal/class/opal_list.h'\fP
.br
\fC#include 'class/ompi_pointer_array.h'\fP
.br
\fC#include 'errhandler/errhandler.h'\fP
.br
\fC#include 'opal/runtime/opal_progress.h'\fP
.br
\fC#include 'opal/threads/mutex.h'\fP
.br
\fC#include 'opal/threads/condition.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBOMPI_REQUEST_INIT\fP(request)"
.br
.RI "\fIInitialize a request. \fP"
.ti -1c
.RI "#define \fBOMPI_REQUEST_FINI\fP(request)"
.br
.RI "\fIFinalize a request. \fP"
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef int(* \fBompi_request_cancel_fn_t\fP )(struct \fBompi_request_t\fP *request, int flag)"
.br
.ti -1c
.RI "typedef \fBompi_request_t\fP \fBompi_request_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.in -1c
.SS "Enumerations"

.in +1c
.ti -1c
.RI "enum \fBompi_request_type_t\fP { \fBOMPI_REQUEST_PML\fP, \fBOMPI_REQUEST_IO\fP, \fBOMPI_REQUEST_GEN\fP, \fBOMPI_REQUEST_NULL\fP, \fBOMPI_REQUEST_MAX\fP }"
.br
.RI "\fIEnum inidicating the type of the request. \fP"
.ti -1c
.RI "enum \fBompi_request_state_t\fP { \fBOMPI_REQUEST_INVALID\fP, \fBOMPI_REQUEST_INACTIVE\fP, \fBOMPI_REQUEST_ACTIVE\fP, \fBOMPI_REQUEST_CANCELLED\fP }"
.br
.RI "\fIEnum indicating the state of the request. \fP"
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC \fBOBJ_CLASS_DECLARATION\fP (\fBompi_request_t\fP)"
.br
.RI "\fIRequest class. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBompi_request_init\fP (void)"
.br
.RI "\fIInitialize the MPI_Request subsystem; invoked during MPI_INIT. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBompi_request_finalize\fP (void)"
.br
.RI "\fIShut down the MPI_Request subsystem; invoked during MPI_FINALIZE. \fP"
.ti -1c
.RI "static int \fBompi_request_cancel\fP (\fBompi_request_t\fP *request)"
.br
.RI "\fICancel a pending request. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBompi_request_complete\fP (\fBompi_request_t\fP *request)"
.br
.RI "\fISignal a request as complete. \fP"
.ti -1c
.RI "static int \fBompi_request_free\fP (\fBompi_request_t\fP **request)"
.br
.RI "\fIFree a request. \fP"
.ti -1c
.RI "static int \fBompi_request_test\fP (\fBompi_request_t\fP **rptr, int *completed, ompi_status_public_t *status)"
.br
.RI "\fINon-blocking test for request completion. \fP"
.ti -1c
.RI "int \fBompi_request_test_any\fP (size_t count, \fBompi_request_t\fP **requests, int *index, int *completed, ompi_status_public_t *status)"
.br
.RI "\fINon-blocking test for request completion. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBompi_request_test_all\fP (size_t count, \fBompi_request_t\fP **requests, int *completed, ompi_status_public_t *statuses)"
.br
.RI "\fINon-blocking test for request completion. \fP"
.ti -1c
.RI "static int \fBompi_request_wait\fP (\fBompi_request_t\fP **req_ptr, ompi_status_public_t *status)"
.br
.RI "\fIWait (blocking-mode) for one requests to complete. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBompi_request_wait_any\fP (size_t count, \fBompi_request_t\fP **requests, int *index, ompi_status_public_t *status)"
.br
.RI "\fIWait (blocking-mode) for one of N requests to complete. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBompi_request_wait_all\fP (size_t count, \fBompi_request_t\fP **requests, ompi_status_public_t *statuses)"
.br
.RI "\fIWait (blocking-mode) for all of N requests to complete. \fP"
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "typedef int(* \fBompi_request_free_fn_t\fP )(struct \fBompi_request_t\fP **rptr)"
.br
.ti -1c
.RI "OMPI_DECLSPEC \fBompi_pointer_array_t\fP \fBompi_request_f_to_c_table\fP"
.br
.RI "\fIGlobals used for tracking requests and request completion. \fP"
.ti -1c
.RI "OMPI_DECLSPEC size_t \fBompi_request_waiting\fP"
.br
.ti -1c
.RI "OMPI_DECLSPEC size_t \fBompi_request_completed\fP"
.br
.ti -1c
.RI "OMPI_DECLSPEC \fBopal_mutex_t\fP \fBompi_request_lock\fP"
.br
.ti -1c
.RI "OMPI_DECLSPEC opal_condition_t \fBompi_request_cond\fP"
.br
.ti -1c
.RI "OMPI_DECLSPEC int \fBompi_request_poll_iterations\fP"
.br
.ti -1c
.RI "OMPI_DECLSPEC \fBompi_request_t\fP \fBompi_request_null\fP"
.br
.ti -1c
.RI "OMPI_DECLSPEC \fBompi_request_t\fP \fBompi_request_empty\fP"
.br
.ti -1c
.RI "OMPI_DECLSPEC ompi_status_public_t \fBompi_status_empty\fP"
.br
.in -1c
.SH "Detailed Description"
.PP 
Top-level description of requests. 


.SH "Define Documentation"
.PP 
.SS "#define OMPI_REQUEST_FINI(request)"
.PP
\fBValue:\fP
.PP
.nf
do { \
        (request)->req_state = OMPI_REQUEST_INVALID; \
        if (MPI_UNDEFINED != (request)->req_f_to_c_index) { \
            ompi_pointer_array_set_item(&ompi_request_f_to_c_table, \
                                        (request)->req_f_to_c_index, NULL); \
            (request)->req_f_to_c_index = MPI_UNDEFINED; \
        } \
    } while (0);
.fi
Finalize a request. 
.PP
This is a macro to avoid function call overhead, since this is typically invoked in the critical performance path (since requests may be re-used, it is possible that we will have to finalize a request multiple times).
.PP
When finalizing a request, if MPI_Request_f2c() was previously invoked on that request, then this request was added to the f2c table, and we need to remove it 
.SS "#define OMPI_REQUEST_INIT(request)"
.PP
\fBValue:\fP
.PP
.nf
do { \
        (request)->req_state = OMPI_REQUEST_INACTIVE; \
        (request)->req_complete = false; \
        (request)->req_f_to_c_index = MPI_UNDEFINED; \
    } while (0);
.fi
Initialize a request. 
.PP
This is a macro to avoid function call overhead, since this is typically invoked in the critical performance path (since requests may be re-used, it is possible that we will have to initialize a request multiple times). 
.SH "Enumeration Type Documentation"
.PP 
.SS "enum \fBompi_request_state_t\fP"
.PP
Enum indicating the state of the request. 
.PP
\fBEnumeration values: \fP
.in +1c
.TP
\fB\fIOMPI_REQUEST_INVALID \fP\fP
Indicates that the request should not be progressed. 
.TP
\fB\fIOMPI_REQUEST_INACTIVE \fP\fP
A defined, but inactive request (i.e., it's valid, but should not be progressed). 
.TP
\fB\fIOMPI_REQUEST_ACTIVE \fP\fP
A valid and progressing request. 
.TP
\fB\fIOMPI_REQUEST_CANCELLED \fP\fP
The request has been cancelled. 
.SS "enum \fBompi_request_type_t\fP"
.PP
Enum inidicating the type of the request. 
.PP
\fBEnumeration values: \fP
.in +1c
.TP
\fB\fIOMPI_REQUEST_PML \fP\fP
MPI point-to-point request. 
.TP
\fB\fIOMPI_REQUEST_IO \fP\fP
MPI-2 IO request. 
.TP
\fB\fIOMPI_REQUEST_GEN \fP\fP
MPI-2 generalized request. 
.TP
\fB\fIOMPI_REQUEST_NULL \fP\fP
NULL request. 
.TP
\fB\fIOMPI_REQUEST_MAX \fP\fP
Maximum request type. 
.SH "Function Documentation"
.PP 
.SS "OMPI_DECLSPEC int ompi_request_complete (\fBompi_request_t\fP * request)"
.PP
Signal a request as complete. 
.PP
Note this will wake any thread pending on the request. 
.SS "static int ompi_request_free (\fBompi_request_t\fP ** request)\fC [inline, static]\fP"
.PP
Free a request. 
.PP
\fBParameters:\fP
.RS 4
\fIrequest\fP (INOUT) Pointer to request. 
.RE
.PP

.SS "static int ompi_request_test (\fBompi_request_t\fP ** rptr, int * completed, ompi_status_public_t * status)\fC [inline, static]\fP"
.PP
Non-blocking test for request completion. 
.PP
\fBParameters:\fP
.RS 4
\fIrequest\fP (IN) Array of requests 
.br
\fIcomplete\fP (OUT) Flag indicating if index is valid (a request completed). 
.br
\fIstatus\fP (OUT) Status of completed request. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or failure status.
.RE
.PP
Note that upon completion, the request is freed, and the request handle at index set to NULL. 
.SS "OMPI_DECLSPEC int ompi_request_test_all (size_t count, \fBompi_request_t\fP ** requests, int * completed, ompi_status_public_t * statuses)"
.PP
Non-blocking test for request completion. 
.PP
\fBParameters:\fP
.RS 4
\fIcount\fP (IN) Number of requests 
.br
\fIrequests\fP (IN) Array of requests 
.br
\fIcompleted\fP (OUT) Flag indicating wether all requests completed. 
.br
\fIstatuses\fP (OUT) Array of completion statuses. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or failure status.
.RE
.PP
This routine returns completed==true if all requests have completed. The statuses parameter is only updated if all requests completed. Likewise, the requests array is not modified (no requests freed), unless all requests have completed. 
.SS "int ompi_request_test_any (size_t count, \fBompi_request_t\fP ** requests, int * index, int * completed, ompi_status_public_t * status)"
.PP
Non-blocking test for request completion. 
.PP
\fBParameters:\fP
.RS 4
\fIcount\fP (IN) Number of requests 
.br
\fIrequest\fP (IN) Array of requests 
.br
\fIindex\fP (OUT) Index of first completed request. 
.br
\fIcomplete\fP (OUT) Flag indicating if index is valid (a request completed). 
.br
\fIstatus\fP (OUT) Status of completed request. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or failure status.
.RE
.PP
Note that upon completion, the request is freed, and the request handle at index set to NULL. 
.SS "static int ompi_request_wait (\fBompi_request_t\fP ** req_ptr, ompi_status_public_t * status)\fC [inline, static]\fP"
.PP
Wait (blocking-mode) for one requests to complete. 
.PP
\fBParameters:\fP
.RS 4
\fIrequest\fP (IN) Pointer to request. 
.br
\fIstatus\fP (OUT) Status of completed request. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or failure status. 
.RE
.PP

.SS "OMPI_DECLSPEC int ompi_request_wait_all (size_t count, \fBompi_request_t\fP ** requests, ompi_status_public_t * statuses)"
.PP
Wait (blocking-mode) for all of N requests to complete. 
.PP
\fBParameters:\fP
.RS 4
\fIcount\fP (IN) Number of requests 
.br
\fIrequests\fP (IN) Array of requests 
.br
\fIstatuses\fP (OUT) Array of completion statuses. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or failure status. 
.RE
.PP

.SS "OMPI_DECLSPEC int ompi_request_wait_any (size_t count, \fBompi_request_t\fP ** requests, int * index, ompi_status_public_t * status)"
.PP
Wait (blocking-mode) for one of N requests to complete. 
.PP
\fBParameters:\fP
.RS 4
\fIcount\fP (IN) Number of requests 
.br
\fIrequests\fP (IN) Array of requests 
.br
\fIindex\fP (OUT) Index into request array of completed request. 
.br
\fIstatus\fP (OUT) Status of completed request. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or failure status. 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
